/*
	SDZHotelServicesImplServiceExample.m
	Provides example and test runs the service's proxy methods.
	Generated by SudzC.com
*/
#import "SDZHotelServicesImplServiceExample.h"
#import "SDZHotelServicesImplService.h"

@implementation SDZHotelServicesImplServiceExample

- (void)run {
	// Create the service
	SDZHotelServicesImplService* service = [SDZHotelServicesImplService service];
	service.logging = YES;
	// service.username = @"username";
	// service.password = @"password";
	

	// Returns SDZAlternatePropertyListResponse*. 
	[service getAlternateProperties:self action:@selector(getAlternatePropertiesHandler:) AlternatePropertyListRequest: [[SDZAlternatePropertyListRequest alloc] init]];

	// Returns SDZHotelRoomAvailabilityResponse*. 
	[service getAvailability:self action:@selector(getAvailabilityHandler:) HotelRoomAvailabilityRequest: [[SDZHotelRoomAvailabilityRequest alloc] init]];

	// Returns SDZHotelRoomCancellationResponse*. 
	[service getCancellation:self action:@selector(getCancellationHandler:) HotelRoomCancellationRequest: [[SDZHotelRoomCancellationRequest alloc] init]];

	// Returns SDZLocationInfoResponse*. 
	[service getGeoLocation:self action:@selector(getGeoLocationHandler:) LocationInfoRequest: [[SDZLocationInfoRequest alloc] init]];

	// Returns SDZHotelInformationResponse*. 
	[service getInformation:self action:@selector(getInformationHandler:) HotelInformationRequest: [[SDZHotelInformationRequest alloc] init]];

	// Returns SDZHotelItineraryResponse*. 
	[service getItinerary:self action:@selector(getItineraryHandler:) HotelItineraryRequest: [[SDZHotelItineraryRequest alloc] init]];

	// Returns SDZHotelListResponse*. 
	[service getList:self action:@selector(getListHandler:) HotelListRequest: [[SDZHotelListRequest alloc] init]];

	// Returns SDZHotelPaymentResponse*. 
	[service getPaymentInfo:self action:@selector(getPaymentInfoHandler:) HotelPaymentRequest: [[SDZv3.HotelPaymentRequest alloc] init]];

	// Returns SDZPingResponse*. 
	[service getPing:self action:@selector(getPingHandler:) PingRequest: [[SDZPingRequest alloc] init]];

	// Returns SDZHotelRateRulesResponse*. 
	[service getRateRules:self action:@selector(getRateRulesHandler:) HotelRateRulesRequest: [[SDZHotelRateRulesRequest alloc] init]];

	// Returns SDZHotelRoomReservationResponse*. 
	[service getReservation:self action:@selector(getReservationHandler:) HotelRoomReservationRequest: [[SDZHotelRoomReservationRequest alloc] init]];

	// Returns SDZHotelRoomImageResponse*. 
	[service getRoomImage:self action:@selector(getRoomImageHandler:) HotelRoomImageRequest: [[SDZHotelRoomImageRequest alloc] init]];
}

	

// Handle the response from getAlternateProperties.
		
- (void) getAlternatePropertiesHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZAlternatePropertyListResponse* result
		SDZAlternatePropertyListResponse* result = (SDZAlternatePropertyListResponse*)value;
	NSLog(@"getAlternateProperties returned the value: %@", result);
			
}
	

// Handle the response from getAvailability.
		
- (void) getAvailabilityHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelRoomAvailabilityResponse* result
		SDZHotelRoomAvailabilityResponse* result = (SDZHotelRoomAvailabilityResponse*)value;
	NSLog(@"getAvailability returned the value: %@", result);
			
}
	

// Handle the response from getCancellation.
		
- (void) getCancellationHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelRoomCancellationResponse* result
		SDZHotelRoomCancellationResponse* result = (SDZHotelRoomCancellationResponse*)value;
	NSLog(@"getCancellation returned the value: %@", result);
			
}
	

// Handle the response from getGeoLocation.
		
- (void) getGeoLocationHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZLocationInfoResponse* result
		SDZLocationInfoResponse* result = (SDZLocationInfoResponse*)value;
	NSLog(@"getGeoLocation returned the value: %@", result);
			
}
	

// Handle the response from getInformation.
		
- (void) getInformationHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelInformationResponse* result
		SDZHotelInformationResponse* result = (SDZHotelInformationResponse*)value;
	NSLog(@"getInformation returned the value: %@", result);
			
}
	

// Handle the response from getItinerary.
		
- (void) getItineraryHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelItineraryResponse* result
		SDZHotelItineraryResponse* result = (SDZHotelItineraryResponse*)value;
	NSLog(@"getItinerary returned the value: %@", result);
			
}
	

// Handle the response from getList.
		
- (void) getListHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelListResponse* result
		SDZHotelListResponse* result = (SDZHotelListResponse*)value;
	NSLog(@"getList returned the value: %@", result);
			
}
	

// Handle the response from getPaymentInfo.
		
- (void) getPaymentInfoHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelPaymentResponse* result
		SDZHotelPaymentResponse* result = (SDZHotelPaymentResponse*)value;
	NSLog(@"getPaymentInfo returned the value: %@", result);
			
}
	

// Handle the response from getPing.
		
- (void) getPingHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZPingResponse* result
		SDZPingResponse* result = (SDZPingResponse*)value;
	NSLog(@"getPing returned the value: %@", result);
			
}
	

// Handle the response from getRateRules.
		
- (void) getRateRulesHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelRateRulesResponse* result
		SDZHotelRateRulesResponse* result = (SDZHotelRateRulesResponse*)value;
	NSLog(@"getRateRules returned the value: %@", result);
			
}
	

// Handle the response from getReservation.
		
- (void) getReservationHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelRoomReservationResponse* result
		SDZHotelRoomReservationResponse* result = (SDZHotelRoomReservationResponse*)value;
	NSLog(@"getReservation returned the value: %@", result);
			
}
	

// Handle the response from getRoomImage.
		
- (void) getRoomImageHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZHotelRoomImageResponse* result
		SDZHotelRoomImageResponse* result = (SDZHotelRoomImageResponse*)value;
	NSLog(@"getRoomImage returned the value: %@", result);
			
}
	

@end
		