/*
	SDZCouponInformationResponse.h
	The implementation of properties and methods for the SDZCouponInformationResponse object.
	Generated by SudzC.com
*/
#import "SDZCouponInformationResponse.h"

#import "SDZCouponErrors.h"
@implementation SDZCouponInformationResponse
	@synthesize type = _type;
	@synthesize amount = _amount;
	@synthesize summary = _summary;
	@synthesize description = _description;
	@synthesize terms = _terms;
	@synthesize ErrorList = _ErrorList;

	- (id) init
	{
		if(self = [super init])
		{
			self.type = nil;
			self.amount = nil;
			self.summary = nil;
			self.description = nil;
			self.terms = nil;
			self.ErrorList = [[[NSMutableArray alloc] init] autorelease];

		}
		return self;
	}

	+ (SDZCouponInformationResponse*) createWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZCouponInformationResponse*)[[[SDZCouponInformationResponse alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.type = [Soap getNodeValue: node withName: @"type"];
			self.amount = [NSDecimalNumber decimalNumberWithString: [Soap getNodeValue: node withName: @"amount"]];
			self.summary = [Soap getNodeValue: node withName: @"summary"];
			self.description = [Soap getNodeValue: node withName: @"description"];
			self.terms = [Soap getNodeValue: node withName: @"terms"];
			self.ErrorList = [[SDZCouponErrors createWithNode: [Soap getNode: node withName: @"ErrorList"]] object];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"CouponInformationResponse"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [NSMutableString string];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return s;
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		if (self.type != nil) [s appendFormat: @"<type>%@</type>", [[self.type stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.amount != nil) [s appendFormat: @"<amount>%@</amount>", [NSString stringWithFormat: @"%@", self.amount]];
		if (self.summary != nil) [s appendFormat: @"<summary>%@</summary>", [[self.summary stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.description != nil) [s appendFormat: @"<description>%@</description>", [[self.description stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.terms != nil) [s appendFormat: @"<terms>%@</terms>", [[self.terms stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.ErrorList != nil && self.ErrorList.count > 0) {
			[s appendFormat: @"<ErrorList>%@</ErrorList>", [SDZCouponErrors serialize: self.ErrorList]];
		} else {
			[s appendString: @"<ErrorList/>"];
		}

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZCouponInformationResponse class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		self.type = nil;
		self.amount = nil;
		self.summary = nil;
		self.description = nil;
		self.terms = nil;
		self.ErrorList = nil;
		[super dealloc];
	}

@end
