/*
	SDZHotel.h
	The implementation of properties and methods for the SDZHotel object.
	Generated by SudzC.com
*/
#import "SDZHotel.h"

@implementation SDZHotel
	@synthesize hotelId = _hotelId;
	@synthesize statusCode = _statusCode;
	@synthesize name = _name;
	@synthesize address1 = _address1;
	@synthesize address2 = _address2;
	@synthesize address3 = _address3;
	@synthesize city = _city;
	@synthesize stateProvinceCode = _stateProvinceCode;
	@synthesize countryCode = _countryCode;
	@synthesize postalCode = _postalCode;
	@synthesize phone = _phone;
	@synthesize fax = _fax;
	@synthesize latitude = _latitude;
	@synthesize longitude = _longitude;
	@synthesize coordinateAccuracyCode = _coordinateAccuracyCode;
	@synthesize lowRate = _lowRate;
	@synthesize highRate = _highRate;
	@synthesize confidence = _confidence;
	@synthesize hotelRating = _hotelRating;
	@synthesize tripAdvisorRating = _tripAdvisorRating;
	@synthesize market = _market;
	@synthesize region = _region;
	@synthesize superRegion = _superRegion;
	@synthesize theme = _theme;

	- (id) init
	{
		if(self = [super init])
		{
			self.statusCode = nil;
			self.name = nil;
			self.address1 = nil;
			self.address2 = nil;
			self.address3 = nil;
			self.city = nil;
			self.stateProvinceCode = nil;
			self.countryCode = nil;
			self.postalCode = nil;
			self.phone = nil;
			self.fax = nil;
			self.coordinateAccuracyCode = nil;
			self.market = nil;
			self.region = nil;
			self.superRegion = nil;
			self.theme = nil;

		}
		return self;
	}

	+ (SDZHotel*) createWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZHotel*)[[[SDZHotel alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.hotelId = [[Soap getNodeValue: node withName: @"hotelId"] longLongValue];
			self.statusCode = [Soap getNodeValue: node withName: @"statusCode"];
			self.name = [Soap getNodeValue: node withName: @"name"];
			self.address1 = [Soap getNodeValue: node withName: @"address1"];
			self.address2 = [Soap getNodeValue: node withName: @"address2"];
			self.address3 = [Soap getNodeValue: node withName: @"address3"];
			self.city = [Soap getNodeValue: node withName: @"city"];
			self.stateProvinceCode = [Soap getNodeValue: node withName: @"stateProvinceCode"];
			self.countryCode = [Soap getNodeValue: node withName: @"countryCode"];
			self.postalCode = [Soap getNodeValue: node withName: @"postalCode"];
			self.phone = [Soap getNodeValue: node withName: @"phone"];
			self.fax = [Soap getNodeValue: node withName: @"fax"];
			self.latitude = [[Soap getNodeValue: node withName: @"latitude"] floatValue];
			self.longitude = [[Soap getNodeValue: node withName: @"longitude"] floatValue];
			self.coordinateAccuracyCode = [Soap getNodeValue: node withName: @"coordinateAccuracyCode"];
			self.lowRate = [[Soap getNodeValue: node withName: @"lowRate"] floatValue];
			self.highRate = [[Soap getNodeValue: node withName: @"highRate"] floatValue];
			self.confidence = [[Soap getNodeValue: node withName: @"confidence"] longLongValue];
			self.hotelRating = [[Soap getNodeValue: node withName: @"hotelRating"] floatValue];
			self.tripAdvisorRating = [[Soap getNodeValue: node withName: @"tripAdvisorRating"] floatValue];
			self.market = [Soap getNodeValue: node withName: @"market"];
			self.region = [Soap getNodeValue: node withName: @"region"];
			self.superRegion = [Soap getNodeValue: node withName: @"superRegion"];
			self.theme = [Soap getNodeValue: node withName: @"theme"];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"Hotel"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [NSMutableString string];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return s;
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		[s appendFormat: @"<hotelId>%@</hotelId>", [NSString stringWithFormat: @"%ld", self.hotelId]];
		if (self.statusCode != nil) [s appendFormat: @"<statusCode>%@</statusCode>", [[self.statusCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.name != nil) [s appendFormat: @"<name>%@</name>", [[self.name stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.address1 != nil) [s appendFormat: @"<address1>%@</address1>", [[self.address1 stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.address2 != nil) [s appendFormat: @"<address2>%@</address2>", [[self.address2 stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.address3 != nil) [s appendFormat: @"<address3>%@</address3>", [[self.address3 stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.city != nil) [s appendFormat: @"<city>%@</city>", [[self.city stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.stateProvinceCode != nil) [s appendFormat: @"<stateProvinceCode>%@</stateProvinceCode>", [[self.stateProvinceCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.countryCode != nil) [s appendFormat: @"<countryCode>%@</countryCode>", [[self.countryCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.postalCode != nil) [s appendFormat: @"<postalCode>%@</postalCode>", [[self.postalCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.phone != nil) [s appendFormat: @"<phone>%@</phone>", [[self.phone stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.fax != nil) [s appendFormat: @"<fax>%@</fax>", [[self.fax stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<latitude>%@</latitude>", [NSString stringWithFormat: @"%f", self.latitude]];
		[s appendFormat: @"<longitude>%@</longitude>", [NSString stringWithFormat: @"%f", self.longitude]];
		if (self.coordinateAccuracyCode != nil) [s appendFormat: @"<coordinateAccuracyCode>%@</coordinateAccuracyCode>", [[self.coordinateAccuracyCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<lowRate>%@</lowRate>", [NSString stringWithFormat: @"%f", self.lowRate]];
		[s appendFormat: @"<highRate>%@</highRate>", [NSString stringWithFormat: @"%f", self.highRate]];
		[s appendFormat: @"<confidence>%@</confidence>", [NSString stringWithFormat: @"%ld", self.confidence]];
		[s appendFormat: @"<hotelRating>%@</hotelRating>", [NSString stringWithFormat: @"%f", self.hotelRating]];
		[s appendFormat: @"<tripAdvisorRating>%@</tripAdvisorRating>", [NSString stringWithFormat: @"%f", self.tripAdvisorRating]];
		if (self.market != nil) [s appendFormat: @"<market>%@</market>", [[self.market stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.region != nil) [s appendFormat: @"<region>%@</region>", [[self.region stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.superRegion != nil) [s appendFormat: @"<superRegion>%@</superRegion>", [[self.superRegion stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.theme != nil) [s appendFormat: @"<theme>%@</theme>", [[self.theme stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZHotel class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		self.statusCode = nil;
		self.name = nil;
		self.address1 = nil;
		self.address2 = nil;
		self.address3 = nil;
		self.city = nil;
		self.stateProvinceCode = nil;
		self.countryCode = nil;
		self.postalCode = nil;
		self.phone = nil;
		self.fax = nil;
		self.coordinateAccuracyCode = nil;
		self.market = nil;
		self.region = nil;
		self.superRegion = nil;
		self.theme = nil;
		[super dealloc];
	}

@end
