/*
	SDZHotelConfirmation.h
	The implementation of properties and methods for the SDZHotelConfirmation object.
	Generated by SudzC.com
*/
#import "SDZHotelConfirmation.h"

#import "SDZHotelRateInfo.h"
#import "SDZRateInfos.h"
#import "SDZCouponInformation.h"
#import "SDZReservationGuest.h"
#import "SDZHotel.h"
#import "SDZConfirmationExtras.h"
@implementation SDZHotelConfirmation
	@synthesize supplierId = _supplierId;
	@synthesize chainCode = _chainCode;
	@synthesize creditCardType = _creditCardType;
	@synthesize arrivalDate = _arrivalDate;
	@synthesize departureDate = _departureDate;
	@synthesize confirmationNumber = _confirmationNumber;
	@synthesize cancellationNumber = _cancellationNumber;
	@synthesize RateInfo = _RateInfo;
	@synthesize RateInfos = _RateInfos;
	@synthesize numberOfAdults = _numberOfAdults;
	@synthesize numberOfChildren = _numberOfChildren;
	@synthesize cancellationPolicy = _cancellationPolicy;
	@synthesize affiliateConfirmationId = _affiliateConfirmationId;
	@synthesize smokingPreference = _smokingPreference;
	@synthesize supplierPropertyId = _supplierPropertyId;
	@synthesize roomType = _roomType;
	@synthesize rateType = _rateType;
	@synthesize rateDescription = _rateDescription;
	@synthesize roomDescription = _roomDescription;
	@synthesize status = _status;
	@synthesize nonRefundable = _nonRefundable;
	@synthesize locale = _locale;
	@synthesize CouponInformation = _CouponInformation;
	@synthesize ReservationGuest = _ReservationGuest;
	@synthesize Hotel = _Hotel;
	@synthesize ConfirmationExtras = _ConfirmationExtras;
	@synthesize nights = _nights;

	- (id) init
	{
		if(self = [super init])
		{
			self.chainCode = nil;
			self.creditCardType = nil;
			self.arrivalDate = nil;
			self.departureDate = nil;
			self.confirmationNumber = nil;
			self.cancellationNumber = nil;
			self.RateInfo = nil; // [[SDZHotelRateInfo alloc] init];
			self.RateInfos = [[[NSMutableArray alloc] init] autorelease];
			self.cancellationPolicy = nil;
			self.affiliateConfirmationId = nil;
			self.smokingPreference = nil;
			self.supplierPropertyId = nil;
			self.roomType = nil;
			self.rateType = nil;
			self.rateDescription = nil;
			self.roomDescription = nil;
			self.status = nil;
			self.locale = nil;
			self.CouponInformation = nil; // [[SDZCouponInformation alloc] init];
			self.ReservationGuest = nil; // [[SDZReservationGuest alloc] init];
			self.Hotel = nil; // [[SDZHotel alloc] init];
			self.ConfirmationExtras = [[[NSMutableArray alloc] init] autorelease];

		}
		return self;
	}

	+ (SDZHotelConfirmation*) createWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZHotelConfirmation*)[[[SDZHotelConfirmation alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.supplierId = [[Soap getNodeValue: node withName: @"supplierId"] longLongValue];
			self.chainCode = [Soap getNodeValue: node withName: @"chainCode"];
			self.creditCardType = [Soap getNodeValue: node withName: @"creditCardType"];
			self.arrivalDate = [Soap getNodeValue: node withName: @"arrivalDate"];
			self.departureDate = [Soap getNodeValue: node withName: @"departureDate"];
			self.confirmationNumber = [Soap getNodeValue: node withName: @"confirmationNumber"];
			self.cancellationNumber = [Soap getNodeValue: node withName: @"cancellationNumber"];
			self.RateInfo = [[SDZHotelRateInfo createWithNode: [Soap getNode: node withName: @"RateInfo"]] object];
			self.RateInfos = [[SDZRateInfos createWithNode: [Soap getNode: node withName: @"RateInfos"]] object];
			self.numberOfAdults = [[Soap getNodeValue: node withName: @"numberOfAdults"] intValue];
			self.numberOfChildren = [[Soap getNodeValue: node withName: @"numberOfChildren"] intValue];
			self.cancellationPolicy = [Soap getNodeValue: node withName: @"cancellationPolicy"];
			self.affiliateConfirmationId = [Soap getNodeValue: node withName: @"affiliateConfirmationId"];
			self.smokingPreference = [Soap getNodeValue: node withName: @"smokingPreference"];
			self.supplierPropertyId = [Soap getNodeValue: node withName: @"supplierPropertyId"];
			self.roomType = [Soap getNodeValue: node withName: @"roomType"];
			self.rateType = [Soap getNodeValue: node withName: @"rateType"];
			self.rateDescription = [Soap getNodeValue: node withName: @"rateDescription"];
			self.roomDescription = [Soap getNodeValue: node withName: @"roomDescription"];
			self.status = [Soap getNodeValue: node withName: @"status"];
			self.nonRefundable = [[Soap getNodeValue: node withName: @"nonRefundable"] boolValue];
			self.locale = [Soap getNodeValue: node withName: @"locale"];
			self.CouponInformation = [[SDZCouponInformation createWithNode: [Soap getNode: node withName: @"CouponInformation"]] object];
			self.ReservationGuest = [[SDZReservationGuest createWithNode: [Soap getNode: node withName: @"ReservationGuest"]] object];
			self.Hotel = [[SDZHotel createWithNode: [Soap getNode: node withName: @"Hotel"]] object];
			self.ConfirmationExtras = [[SDZConfirmationExtras createWithNode: [Soap getNode: node withName: @"ConfirmationExtras"]] object];
			self.nights = [[Soap getNodeValue: node withName: @"nights"] intValue];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"HotelConfirmation"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [NSMutableString string];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return s;
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		[s appendFormat: @"<supplierId>%@</supplierId>", [NSString stringWithFormat: @"%ld", self.supplierId]];
		if (self.chainCode != nil) [s appendFormat: @"<chainCode>%@</chainCode>", [[self.chainCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.creditCardType != nil) [s appendFormat: @"<creditCardType>%@</creditCardType>", [[self.creditCardType stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.arrivalDate != nil) [s appendFormat: @"<arrivalDate>%@</arrivalDate>", [[self.arrivalDate stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.departureDate != nil) [s appendFormat: @"<departureDate>%@</departureDate>", [[self.departureDate stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.confirmationNumber != nil) [s appendFormat: @"<confirmationNumber>%@</confirmationNumber>", [[self.confirmationNumber stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.cancellationNumber != nil) [s appendFormat: @"<cancellationNumber>%@</cancellationNumber>", [[self.cancellationNumber stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.RateInfo != nil) [s appendString: [self.RateInfo serialize: @"RateInfo"]];
		if (self.RateInfos != nil && self.RateInfos.count > 0) {
			[s appendFormat: @"<RateInfos>%@</RateInfos>", [SDZRateInfos serialize: self.RateInfos]];
		} else {
			[s appendString: @"<RateInfos/>"];
		}
		[s appendFormat: @"<numberOfAdults>%@</numberOfAdults>", [NSString stringWithFormat: @"%i", self.numberOfAdults]];
		[s appendFormat: @"<numberOfChildren>%@</numberOfChildren>", [NSString stringWithFormat: @"%i", self.numberOfChildren]];
		if (self.cancellationPolicy != nil) [s appendFormat: @"<cancellationPolicy>%@</cancellationPolicy>", [[self.cancellationPolicy stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.affiliateConfirmationId != nil) [s appendFormat: @"<affiliateConfirmationId>%@</affiliateConfirmationId>", [[self.affiliateConfirmationId stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.smokingPreference != nil) [s appendFormat: @"<smokingPreference>%@</smokingPreference>", [[self.smokingPreference stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.supplierPropertyId != nil) [s appendFormat: @"<supplierPropertyId>%@</supplierPropertyId>", [[self.supplierPropertyId stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.roomType != nil) [s appendFormat: @"<roomType>%@</roomType>", [[self.roomType stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.rateType != nil) [s appendFormat: @"<rateType>%@</rateType>", [[self.rateType stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.rateDescription != nil) [s appendFormat: @"<rateDescription>%@</rateDescription>", [[self.rateDescription stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.roomDescription != nil) [s appendFormat: @"<roomDescription>%@</roomDescription>", [[self.roomDescription stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.status != nil) [s appendFormat: @"<status>%@</status>", [[self.status stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<nonRefundable>%@</nonRefundable>", (self.nonRefundable)?@"true":@"false"];
		if (self.locale != nil) [s appendFormat: @"<locale>%@</locale>", [[self.locale stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.CouponInformation != nil) [s appendString: [self.CouponInformation serialize: @"CouponInformation"]];
		if (self.ReservationGuest != nil) [s appendString: [self.ReservationGuest serialize: @"ReservationGuest"]];
		if (self.Hotel != nil) [s appendString: [self.Hotel serialize: @"Hotel"]];
		if (self.ConfirmationExtras != nil && self.ConfirmationExtras.count > 0) {
			[s appendFormat: @"<ConfirmationExtras>%@</ConfirmationExtras>", [SDZConfirmationExtras serialize: self.ConfirmationExtras]];
		} else {
			[s appendString: @"<ConfirmationExtras/>"];
		}
		[s appendFormat: @"<nights>%@</nights>", [NSString stringWithFormat: @"%i", self.nights]];

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZHotelConfirmation class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		self.chainCode = nil;
		self.creditCardType = nil;
		self.arrivalDate = nil;
		self.departureDate = nil;
		self.confirmationNumber = nil;
		self.cancellationNumber = nil;
		self.RateInfo = nil;
		self.RateInfos = nil;
		self.cancellationPolicy = nil;
		self.affiliateConfirmationId = nil;
		self.smokingPreference = nil;
		self.supplierPropertyId = nil;
		self.roomType = nil;
		self.rateType = nil;
		self.rateDescription = nil;
		self.roomDescription = nil;
		self.status = nil;
		self.locale = nil;
		self.CouponInformation = nil;
		self.ReservationGuest = nil;
		self.Hotel = nil;
		self.ConfirmationExtras = nil;
		[super dealloc];
	}

@end
