/*
	SDZHotelInfo.h
	The implementation of properties and methods for the SDZHotelInfo object.
	Generated by SudzC.com
*/
#import "SDZHotelInfo.h"

@implementation SDZHotelInfo
	@synthesize hotelId = _hotelId;
	@synthesize name = _name;
	@synthesize address = _address;
	@synthesize city = _city;
	@synthesize stateProvinceCode = _stateProvinceCode;
	@synthesize countryCode = _countryCode;
	@synthesize postalCode = _postalCode;
	@synthesize starRating = _starRating;
	@synthesize thumbnailUrl = _thumbnailUrl;
	@synthesize locationDescription = _locationDescription;

	- (id) init
	{
		if(self = [super init])
		{
			self.name = nil;
			self.address = nil;
			self.city = nil;
			self.stateProvinceCode = nil;
			self.countryCode = nil;
			self.postalCode = nil;
			self.thumbnailUrl = nil;
			self.locationDescription = nil;

		}
		return self;
	}

	+ (SDZHotelInfo*) createWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZHotelInfo*)[[[SDZHotelInfo alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.hotelId = [[Soap getNodeValue: node withName: @"hotelId"] longLongValue];
			self.name = [Soap getNodeValue: node withName: @"name"];
			self.address = [Soap getNodeValue: node withName: @"address"];
			self.city = [Soap getNodeValue: node withName: @"city"];
			self.stateProvinceCode = [Soap getNodeValue: node withName: @"stateProvinceCode"];
			self.countryCode = [Soap getNodeValue: node withName: @"countryCode"];
			self.postalCode = [Soap getNodeValue: node withName: @"postalCode"];
			self.starRating = [[Soap getNodeValue: node withName: @"starRating"] floatValue];
			self.thumbnailUrl = [Soap getNodeValue: node withName: @"thumbnailUrl"];
			self.locationDescription = [Soap getNodeValue: node withName: @"locationDescription"];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"HotelInfo"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [NSMutableString string];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return s;
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		[s appendFormat: @"<hotelId>%@</hotelId>", [NSString stringWithFormat: @"%ld", self.hotelId]];
		if (self.name != nil) [s appendFormat: @"<name>%@</name>", [[self.name stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.address != nil) [s appendFormat: @"<address>%@</address>", [[self.address stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.city != nil) [s appendFormat: @"<city>%@</city>", [[self.city stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.stateProvinceCode != nil) [s appendFormat: @"<stateProvinceCode>%@</stateProvinceCode>", [[self.stateProvinceCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.countryCode != nil) [s appendFormat: @"<countryCode>%@</countryCode>", [[self.countryCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.postalCode != nil) [s appendFormat: @"<postalCode>%@</postalCode>", [[self.postalCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<starRating>%@</starRating>", [NSString stringWithFormat: @"%f", self.starRating]];
		if (self.thumbnailUrl != nil) [s appendFormat: @"<thumbnailUrl>%@</thumbnailUrl>", [[self.thumbnailUrl stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.locationDescription != nil) [s appendFormat: @"<locationDescription>%@</locationDescription>", [[self.locationDescription stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZHotelInfo class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		self.name = nil;
		self.address = nil;
		self.city = nil;
		self.stateProvinceCode = nil;
		self.countryCode = nil;
		self.postalCode = nil;
		self.thumbnailUrl = nil;
		self.locationDescription = nil;
		[super dealloc];
	}

@end
