/*
	SDZHotelRoomAvailabilityRequest.h
	The implementation of properties and methods for the SDZHotelRoomAvailabilityRequest object.
	Generated by SudzC.com
*/
#import "SDZHotelRoomAvailabilityRequest.h"

#import "SDZRoomGroup.h"
#import "SDZCouponData.h"
@implementation SDZHotelRoomAvailabilityRequest
	@synthesize hotelId = _hotelId;
	@synthesize arrivalDate = _arrivalDate;
	@synthesize departureDate = _departureDate;
	@synthesize numberOfBedRooms = _numberOfBedRooms;
	@synthesize supplierType = _supplierType;
	@synthesize rateKey = _rateKey;
	@synthesize RoomGroup = _RoomGroup;
	@synthesize rateType = _rateType;
	@synthesize rateCode = _rateCode;
	@synthesize roomTypeCode = _roomTypeCode;
	@synthesize includeRoomImages = _includeRoomImages;
	@synthesize CouponData = _CouponData;
	@synthesize includeDetails = _includeDetails;
	@synthesize multiRoomAvail = _multiRoomAvail;
	@synthesize options = _options;

	- (id) init
	{
		if(self = [super init])
		{
			self.arrivalDate = nil;
			self.departureDate = nil;
			self.supplierType = nil;
			self.rateKey = nil;
			self.RoomGroup = [[[NSMutableArray alloc] init] autorelease];
			self.rateType = nil;
			self.rateCode = nil;
			self.roomTypeCode = nil;
			self.CouponData = nil; // [[SDZCouponData alloc] init];
			self.multiRoomAvail = nil;
			self.options = nil;

		}
		return self;
	}

	+ (SDZHotelRoomAvailabilityRequest*) createWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZHotelRoomAvailabilityRequest*)[[[SDZHotelRoomAvailabilityRequest alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.hotelId = [[Soap getNodeValue: node withName: @"hotelId"] longLongValue];
			self.arrivalDate = [Soap getNodeValue: node withName: @"arrivalDate"];
			self.departureDate = [Soap getNodeValue: node withName: @"departureDate"];
			self.numberOfBedRooms = [[Soap getNodeValue: node withName: @"numberOfBedRooms"] intValue];
			self.supplierType = [Soap getNodeValue: node withName: @"supplierType"];
			self.rateKey = [Soap getNodeValue: node withName: @"rateKey"];
			self.RoomGroup = [[SDZRoomGroup createWithNode: [Soap getNode: node withName: @"RoomGroup"]] object];
			self.rateType = [Soap getNodeValue: node withName: @"rateType"];
			self.rateCode = [Soap getNodeValue: node withName: @"rateCode"];
			self.roomTypeCode = [Soap getNodeValue: node withName: @"roomTypeCode"];
			self.includeRoomImages = [[Soap getNodeValue: node withName: @"includeRoomImages"] boolValue];
			self.CouponData = [[SDZCouponData createWithNode: [Soap getNode: node withName: @"CouponData"]] object];
			self.includeDetails = [[Soap getNodeValue: node withName: @"includeDetails"] boolValue];
			self.multiRoomAvail = [Soap getNodeValue: node withName: @"multiRoomAvail"];
			self.options = [Soap getNodeValue: node withName: @"options"];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"HotelRoomAvailabilityRequest"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [NSMutableString string];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return s;
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		[s appendFormat: @"<hotelId>%@</hotelId>", [NSString stringWithFormat: @"%ld", self.hotelId]];
		if (self.arrivalDate != nil) [s appendFormat: @"<arrivalDate>%@</arrivalDate>", [[self.arrivalDate stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.departureDate != nil) [s appendFormat: @"<departureDate>%@</departureDate>", [[self.departureDate stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<numberOfBedRooms>%@</numberOfBedRooms>", [NSString stringWithFormat: @"%i", self.numberOfBedRooms]];
		if (self.supplierType != nil) [s appendFormat: @"<supplierType>%@</supplierType>", [[self.supplierType stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.rateKey != nil) [s appendFormat: @"<rateKey>%@</rateKey>", [[self.rateKey stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.RoomGroup != nil && self.RoomGroup.count > 0) {
			[s appendFormat: @"<RoomGroup>%@</RoomGroup>", [SDZRoomGroup serialize: self.RoomGroup]];
		} else {
			[s appendString: @"<RoomGroup/>"];
		}
		if (self.rateType != nil) [s appendFormat: @"<rateType>%@</rateType>", [[self.rateType stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.rateCode != nil) [s appendFormat: @"<rateCode>%@</rateCode>", [[self.rateCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.roomTypeCode != nil) [s appendFormat: @"<roomTypeCode>%@</roomTypeCode>", [[self.roomTypeCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<includeRoomImages>%@</includeRoomImages>", (self.includeRoomImages)?@"true":@"false"];
		if (self.CouponData != nil) [s appendString: [self.CouponData serialize: @"CouponData"]];
		[s appendFormat: @"<includeDetails>%@</includeDetails>", (self.includeDetails)?@"true":@"false"];
		if (self.multiRoomAvail != nil) [s appendFormat: @"<multiRoomAvail>%@</multiRoomAvail>", [[self.multiRoomAvail stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.options != nil) [s appendFormat: @"<options>%@</options>", [[self.options stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZHotelRoomAvailabilityRequest class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		self.arrivalDate = nil;
		self.departureDate = nil;
		self.supplierType = nil;
		self.rateKey = nil;
		self.RoomGroup = nil;
		self.rateType = nil;
		self.rateCode = nil;
		self.roomTypeCode = nil;
		self.CouponData = nil;
		self.multiRoomAvail = nil;
		self.options = nil;
		[super dealloc];
	}

@end
