/*
	SDZbaseRateInfo.h
	The implementation of properties and methods for the SDZbaseRateInfo object.
	Generated by SudzC.com
*/
#import "SDZbaseRateInfo.h"

#import "SDZbaseRateInfoDiscounts.h"
#import "SDZbaseRateInfoNightlyRatesPerRoom.h"
#import "SDZbaseRateInfoSurcharges.h"
@implementation SDZbaseRateInfo
	@synthesize Discounts = _Discounts;
	@synthesize NightlyRatesPerRoom = _NightlyRatesPerRoom;
	@synthesize promoDescription = _promoDescription;
	@synthesize Surcharges = _Surcharges;
	@synthesize averageBaseRate = _averageBaseRate;
	@synthesize averageRate = _averageRate;
	@synthesize commissionableUsdTotal = _commissionableUsdTotal;
	@synthesize currencyCode = _currencyCode;
	@synthesize discountTotal = _discountTotal;
	@synthesize eanCompensationOffline = _eanCompensationOffline;
	@synthesize eanCompensationOnline = _eanCompensationOnline;
	@synthesize maxNightlyRate = _maxNightlyRate;
	@synthesize nightlyRateTotal = _nightlyRateTotal;
	@synthesize grossProfitOffline = _grossProfitOffline;
	@synthesize grossProfitOnline = _grossProfitOnline;
	@synthesize surchargeTotal = _surchargeTotal;
	@synthesize total = _total;

	- (id) init
	{
		if(self = [super init])
		{
			self.Discounts = nil; // [[SDZbaseRateInfoDiscounts alloc] init];
			self.NightlyRatesPerRoom = nil; // [[SDZbaseRateInfoNightlyRatesPerRoom alloc] init];
			self.promoDescription = nil;
			self.Surcharges = nil; // [[SDZbaseRateInfoSurcharges alloc] init];
			self.currencyCode = nil;
			self.eanCompensationOffline = nil;
			self.eanCompensationOnline = nil;
			self.grossProfitOffline = nil;
			self.grossProfitOnline = nil;

		}
		return self;
	}

	+ (SDZbaseRateInfo*) createWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZbaseRateInfo*)[[[SDZbaseRateInfo alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.Discounts = [[SDZbaseRateInfoDiscounts createWithNode: [Soap getNode: node withName: @"Discounts"]] object];
			self.NightlyRatesPerRoom = [[SDZbaseRateInfoNightlyRatesPerRoom createWithNode: [Soap getNode: node withName: @"NightlyRatesPerRoom"]] object];
			self.promoDescription = [Soap getNodeValue: node withName: @"promoDescription"];
			self.Surcharges = [[SDZbaseRateInfoSurcharges createWithNode: [Soap getNode: node withName: @"Surcharges"]] object];
			self.averageBaseRate = [[Soap getNodeValue: node withName: @"averageBaseRate"] floatValue];
			self.averageRate = [[Soap getNodeValue: node withName: @"averageRate"] floatValue];
			self.commissionableUsdTotal = [[Soap getNodeValue: node withName: @"commissionableUsdTotal"] floatValue];
			self.currencyCode = [Soap getNodeValue: node withName: @"currencyCode"];
			self.discountTotal = [[Soap getNodeValue: node withName: @"discountTotal"] floatValue];
			self.eanCompensationOffline = [NSDecimalNumber decimalNumberWithString: [Soap getNodeValue: node withName: @"eanCompensationOffline"]];
			self.eanCompensationOnline = [NSDecimalNumber decimalNumberWithString: [Soap getNodeValue: node withName: @"eanCompensationOnline"]];
			self.maxNightlyRate = [[Soap getNodeValue: node withName: @"maxNightlyRate"] floatValue];
			self.nightlyRateTotal = [[Soap getNodeValue: node withName: @"nightlyRateTotal"] floatValue];
			self.grossProfitOffline = [NSDecimalNumber decimalNumberWithString: [Soap getNodeValue: node withName: @"grossProfitOffline"]];
			self.grossProfitOnline = [NSDecimalNumber decimalNumberWithString: [Soap getNodeValue: node withName: @"grossProfitOnline"]];
			self.surchargeTotal = [[Soap getNodeValue: node withName: @"surchargeTotal"] floatValue];
			self.total = [[Soap getNodeValue: node withName: @"total"] floatValue];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"baseRateInfo"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [NSMutableString string];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return s;
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		if (self.Discounts != nil) [s appendString: [self.Discounts serialize: @"Discounts"]];
		if (self.NightlyRatesPerRoom != nil) [s appendString: [self.NightlyRatesPerRoom serialize: @"NightlyRatesPerRoom"]];
		if (self.promoDescription != nil) [s appendFormat: @"<promoDescription>%@</promoDescription>", [[self.promoDescription stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.Surcharges != nil) [s appendString: [self.Surcharges serialize: @"Surcharges"]];

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];
		[s appendFormat: @" averageBaseRate=\"%@\"", [NSString stringWithFormat: @"%f", self.averageBaseRate]];
		[s appendFormat: @" averageRate=\"%@\"", [NSString stringWithFormat: @"%f", self.averageRate]];
		[s appendFormat: @" commissionableUsdTotal=\"%@\"", [NSString stringWithFormat: @"%f", self.commissionableUsdTotal]];
		if (self.currencyCode != nil) [s appendFormat: @" currencyCode=\"%@\"", [[self.currencyCode stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @" discountTotal=\"%@\"", [NSString stringWithFormat: @"%f", self.discountTotal]];
		if (self.eanCompensationOffline != nil) [s appendFormat: @" eanCompensationOffline=\"%@\"", [NSString stringWithFormat: @"%@", self.eanCompensationOffline]];
		if (self.eanCompensationOnline != nil) [s appendFormat: @" eanCompensationOnline=\"%@\"", [NSString stringWithFormat: @"%@", self.eanCompensationOnline]];
		[s appendFormat: @" maxNightlyRate=\"%@\"", [NSString stringWithFormat: @"%f", self.maxNightlyRate]];
		[s appendFormat: @" nightlyRateTotal=\"%@\"", [NSString stringWithFormat: @"%f", self.nightlyRateTotal]];
		if (self.grossProfitOffline != nil) [s appendFormat: @" grossProfitOffline=\"%@\"", [NSString stringWithFormat: @"%@", self.grossProfitOffline]];
		if (self.grossProfitOnline != nil) [s appendFormat: @" grossProfitOnline=\"%@\"", [NSString stringWithFormat: @"%@", self.grossProfitOnline]];
		[s appendFormat: @" surchargeTotal=\"%@\"", [NSString stringWithFormat: @"%f", self.surchargeTotal]];
		[s appendFormat: @" total=\"%@\"", [NSString stringWithFormat: @"%f", self.total]];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZbaseRateInfo class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		self.Discounts = nil;
		self.NightlyRatesPerRoom = nil;
		self.promoDescription = nil;
		self.Surcharges = nil;
		self.currencyCode = nil;
		self.eanCompensationOffline = nil;
		self.eanCompensationOnline = nil;
		self.grossProfitOffline = nil;
		self.grossProfitOnline = nil;
		[super dealloc];
	}

@end
